% funkce pro aktualizaci simulanho modelu (m vliv jem pi pouit Simulinku)
function gar_update_model(GAR)

%%  ulozeni parametru (aktualizace simulacniho modelu)
    open_system('soustava3')
    warning('off', 'all');
%    get_param('soustava3/Dead_Zone', 'DialogParameters')

    set_param('soustava3', 'StopTime', ...
        num2str(GAR.Optimization_Info.Simulation_Time))
    set_param('soustava3', 'MaxStep', ...
        num2str(round(1000*GAR.Optimization_Info.Simulation_Time/...
                GAR.Optimization_Info.Simulation_Time_Steps_Minimum)/1000))
   
    set_param('soustava3/zadanahodnota', 'After', ...
        num2str(GAR.Control_Requirements.Set_Value))
    set_param('soustava3/t_delay', 'DelayTime', ...
        num2str(GAR.Model_Settings.t_delay))
    set_param('soustava3/Saturation', 'UpperLimit', ...
        num2str(GAR.Model_Settings.Saturation_UpperLimit))
    set_param('soustava3/Saturation', 'LowerLimit', ...
        num2str(GAR.Model_Settings.Saturation_LowerLimit))
    set_param('soustava3/DeadZone', 'LowerValue', ...
        num2str(GAR.Model_Settings.DeadZone_LowerLimit))
    set_param('soustava3/DeadZone', 'UpperValue', ...
        num2str(GAR.Model_Settings.DeadZone_UpperLimit))
    
    if GAR.Model_Settings.Optimize_Sampling_Period
    set_param('soustava3/regulator/PSD', 'SampleTime','Ts')
     %set_param('soustava3/regulator/PSD/Unit Delay1', 'SampleTime','Ts')
     %set_param('soustava3/regulator/PSD/Gain1', 'Gain','Ts/I')
     %set_param('soustava3/regulator/PSD/Gain2', 'Gain','D/Ts')
    else
    set_param('soustava3/regulator/PSD', 'SampleTime',...
        num2str(GAR.Model_Settings.vzorkovani_regulatoru))
         %set_param('soustava3/regulator/PSD/Unit Delay1', 'SampleTime',...
         %    num2str(GAR.Model_Settings.vzorkovani_regulatoru))
         %set_param('soustava3/regulator/PSD/Gain1', 'Gain',...
         %    [num2str(GAR.Model_Settings.vzorkovani_regulatoru) '/I'])
         %set_param('soustava3/regulator/PSD/Gain2', 'Gain',...
         %    ['D/' num2str(GAR.Model_Settings.vzorkovani_regulatoru)])
    end
    
    set_param('soustava3/ZOH1', 'SampleTime', ...
        num2str(GAR.Model_Settings.vzorkovani_vystupu))
    set_param('soustava3/RandomGenerator', 'SampleTime', ...
        num2str(min(GAR.Model_Settings.vzorkovani_regulatoru,...
                GAR.Model_Settings.vzorkovani_vystupu)))
    set_param('soustava3/RandomGenerator', 'Minimum',...
        num2str(-GAR.Model_Settings.Noise_In_Feedback_Size))
    set_param('soustava3/RandomGenerator', 'Maximum',...
        num2str(GAR.Model_Settings.Noise_In_Feedback_Size))
     %set_param('soustava3/WhiteNoise', 'Cov',...
     %    num2str(GAR.Model_Settings.Noise_In_System_Size))
    set_param('soustava3/RandomGenerator1', 'Minimum',...
        num2str(-GAR.Model_Settings.Noise_In_System_Size))
    set_param('soustava3/RandomGenerator1', 'Maximum',...
        num2str(GAR.Model_Settings.Noise_In_System_Size))
    set_param('soustava3/ZOH2', 'SampleTime', ...
        num2str(GAR.Model_Settings.vzorkovani_vystupu*10))
    
    set_param('soustava3/TF1', 'Numerator', ...
        ['[' num2str(GAR.Model_Settings.System_num) ']'])
    set_param('soustava3/TF1', 'Denominator', ...
        ['[' num2str(GAR.Model_Settings.System_den) ']'])
    
    set_param('soustava3/sample_off', 'Value', ...
        num2str(~GAR.Model_Settings.vzorkovani_regulatoru_on))
    set_param('soustava3/sample2_off', 'Value', ...
        num2str(~GAR.Model_Settings.vzorkovani_vystupu_on))
    set_param('soustava3/dzone_off', 'Value', ...
        num2str(~GAR.Model_Settings.DeadZone_On))
    set_param('soustava3/satur_off', 'Value', ...
        num2str(~GAR.Model_Settings.Saturation_On))
    set_param('soustava3/noise_on', 'Value', ...
        num2str(GAR.Model_Settings.Noise_In_System_On))
    set_param('soustava3/rand_on', 'Value', ...
        num2str(GAR.Model_Settings.Noise_In_Feedback_On))
    
    save_system('soustava3')
    warning('on', 'all');
    close_system('soustava3')
