% optimalizace gerultor pomoc GA - hlavn funkce
function [GAR,reg,Z,P,K,KID,Ts,FVAL]=optimalizace(SOUSTAVAxy,pocet_iteraci,t_sim,gar_type)

%%  vlastnosti GA optimalizanho problmu
    GAR = gar_basic_settings(SOUSTAVAxy, gar_type, t_sim, pocet_iteraci);
    GAR = gar_additional_settings(GAR);
%%  nacteni optimalizacniho problemu, nastaveni parametru
    GAR = gar_update_solver(GAR);
%%  zadani dynamiky soustavy,  nacteni hodnot,  kontrola 
    GAR = gar_test_model_settings(GAR);
    if GAR.Optimization_Info.Error_in_parameters 
        reg=tf(0); Z=0; P=0; K=0; KID=0; Ts=0; FVAL=0; return; 
    end
%%  ulozeni parametru (aktualizace simulacniho modelu)
    if strcmp(GAR.Optimization_Info.GAR_type,'GAPID')
        gar_update_modelPID(GAR);
    else
        gar_update_model(GAR);
    end

%%  naten optimalizanho problmu
    load 'optimproblem1.mat'
	
%%  spusteni optimalizace

    %   smycka v niz probihaji iterace...
    for i=1:ceil(GAR.Optimization_Info.Iterations_Count/GAR.Optimization_Info.Plot_Interval)
    %   samotny proces optimalizace (pomoci genetickeho algoritmu)
        warning('off','gads:initialPopulationCheck:initPopLength');
        [X,FVAL,EXITFLAG,OUTPUT,POPULATION,SCORES] = ga(...
            optimproblem1.fitnessfcn,optimproblem1.nvars,...
            [],[],[],[],[GAR.GA_Matlab.min_rozsahu],[GAR.GA_Matlab.max_rozsahu],[],optimproblem1.options);

        optimproblem1.options=gaoptimset(optimproblem1.options, ...
        'InitialPopulation',POPULATION,'InitialScores',SCORES);

%%  vpis vysledku
    gar_results_printing(GAR,X,FVAL,i);
%%  screen prbnch vsledk
    if GAR.Optimization_Info.Screen_saveing
        gar_screen_saving(GAR,X,i); 
    end
%%  kratka prodleva pred dalsimi iteracemi
    pause(0.1)
    end
    
    [reg,Z,P,K,KID,Ts]=gar_reg_rek(GAR, X);  %rekonstrukce regultoru (nvratov parametry)
    
end