% vykresleni (mezi)vysledku - funkce pro ziskani dat 
function [control_value, tout0, control_action, tout1]=vykresleni(GAR, KID)

t=GAR.Optimization_Info.Simulation_Time;

%%  parametry regultoru
[Z,P,K,Ts]=transformace(GAR, KID);

%%  simulace
try
    if GAR.Optimization_Info.Use_Simulink_model
        warning('off', 'all');
        sim('./soustava3.mdl',[],simset('SrcWorkspace', 'current'))
        warning('on', 'all');
        control_value=simout.signals.values;
        tout0=simout.time;
        control_action=simout1.signals.values;
        tout1=simout1.time;
    else
        regulator_xy=tf(zpk(Z,P,K));
        system_tf=GAR.Model_Settings.System_TF;
        tout0=linspace(0,t,5000); tout1=tout0;
        forward_track=series(regulator_xy,system_tf);
        if GAR.Model_Settings.t_delay
            forward_track=ss(forward_track);
            regulator_xy=ss(regulator_xy);
            system_tf=ss(system_tf);
        end
        control_loop=feedback(forward_track,1);
        control_value=step(control_loop,tout0)';
        action_loop=feedback(regulator_xy,system_tf);
        control_action=step(action_loop,tout0)';
    end
catch
    control_value=0;
    tout0=0;
    control_action=0;
    tout1=0;
end