% funkce generujc datovou strukturu s nastavenmi optimalizanho problmu
function gar_basic_settings
%%  globalni promenne
global GAR
global fitness_history;

%%  vlastnosti GA
GAR.GA_Matlab.velikost_populace=50;
GAR.GA_Matlab.typ_krizeni=1;          %1-rozptlen, 2-jednobodov, 3-dvoubodov, 4-vhovan, 5-heuristick
GAR.GA_Matlab.typ_vyberu_jedince=1;   %1-stochastick, 2-jednotn, 3-ruleta, 4-turnaj
GAR.GA_Matlab.druh_mutace=1;          %1-adaptivn, 2-uniformn, 3-gausovsk
switch(GAR.Optimization_Info.GAR_type)
    case 'GAR3K'
        GAR.GA_Matlab.delka_DNA=10;
        GAR.SimulacniModel='./soustava3.mdl';
    case 'GAR5R'
        GAR.GA_Matlab.delka_DNA=12;
        GAR.SimulacniModel='./soustava3.mdl';
    case 'GAR5K'
        GAR.GA_Matlab.delka_DNA=22;
        GAR.SimulacniModel='./soustava3.mdl';
    case 'GAPID'
        GAR.GA_Matlab.delka_DNA=5;
        GAR.SimulacniModel='./soustava_pid.mdl';
end 

% zozsah cisel generovanch pomoc GA
GAR.GA_Matlab.min_rozsahu=-1000000;
GAR.GA_Matlab.max_rozsahu=1000000;

[num_soustavy den_soustavy]=tfdata(GAR.Model_Settings.System_TF);
GAR.Model_Settings.System_num=num_soustavy{1};
GAR.Model_Settings.System_den=den_soustavy{1};

%% pozadavky na regulacni dej
GAR.Control_Requirements.Set_Value=1;
GAR.Control_Requirements.Max_Overshoot=1;
GAR.Control_Requirements.Integral_criterium=3; %1-lin., 2-kvad., 3-ITAE
GAR.Control_Requirements.Other_criteria=1; 

%% nastaveni regulatoru
GAR.Model_Settings.vzorkovani_regulatoru_on=0;         %ANO/NE
GAR.Model_Settings.Optimize_Sampling_Period=0;      %ANO/NE
GAR.Model_Settings.vzorkovani_regulatoru=0.1;
GAR.Model_Settings.vzorkovani_vystupu_on=0;            %ANO/NE
GAR.Model_Settings.vzorkovani_vystupu=0.1;     %vzorkovani snimace na vystupu soustavy, tj. hodnota pro zpetnou vazbu
GAR.Model_Settings.Put_Integrator_Into_GAR=1;

%% nastaveni nelinearit a ruseni
GAR.Model_Settings.t_delay=GAR.Model_Settings.System_TF.inputdelay+...
    GAR.Model_Settings.System_TF.outputdelay;
GAR.Model_Settings.Saturation_On=0;          %ANO/NE
GAR.Model_Settings.Saturation_LowerLimit=-10;
GAR.Model_Settings.Saturation_UpperLimit=10;
GAR.Model_Settings.DeadZone_On=0;            %ANO/NE
GAR.Model_Settings.DeadZone_LowerLimit=-0.01;
GAR.Model_Settings.DeadZone_UpperLimit=0.01;
GAR.Model_Settings.Noise_In_Feedback_On=0;   %ANO/NE
GAR.Model_Settings.Noise_In_Feedback_Size=0.03;
GAR.Model_Settings.Noise_In_System_On=0;     %ANO/NE
GAR.Model_Settings.Noise_In_System_Size=0.0005;

%% dalsi parametry simulace
GAR.Optimization_Info.Second_Graph=0;           %0-akcni zasah, 1-fitness
GAR.Optimization_Info.Screen_saveing=0;
GAR.Optimization_Info.Plot_Interval=10;
GAR.Optimization_Info.Display_Fitness=0;
% GAR.Optimization_Info.Simulation_Time=t;        %delka casove osy
GAR.Optimization_Info.Simulation_Time_Modify=0;        
GAR.Optimization_Info.Simulation_Time_Steps_Minimum=200;
GAR.Optimization_Info.Error_in_parameters=0;
GAR.Optimization_Info.Use_Simulink_model=0;
GAR.Optimization_Info.individuals_ok=0;
GAR.Optimization_Info.individuals_error=0;
% GAR.Optimization_Info.Iterations_Count=0;

fitness_history=zeros(1,50);