% optimalizace gerultor pomoc GA - hlavn funkce
function [reg,Z,P,K,KID,Ts,FVAL]=optimalizace(SOUSTAVAxy,pocet_iteraci,t,gar_type)
global GAR;

GAR.Optimization_Info.Simulation_Time=t;
GAR.Optimization_Info.Iterations_Count=pocet_iteraci;
GAR.Model_Settings.System_TF=SOUSTAVAxy;
GAR.Optimization_Info.GAR_type=gar_type;

%%  vlastnosti GA optimalizanho problmu
    gar_basic_settings();
    gar_additional_settings();
%%  nacteni optimalizacniho problemu, nastaveni parametru
    gar_solver_update();
%%  zadani dynamiky soustavy,  nacteni hodnot,  kontrola 
    if gar_test_model_settings() 
        reg=tf(0); Z=0; P=0; K=0; KID=0; Ts=0; FVAL=0; return; 
    end
%%  ulozeni parametru (aktualizace simulacniho modelu)
    if strcmp(GAR.Optimization_Info.GAR_type,'GAPID')
        gar_modelPID_update();
    else
        gar_model_update();
    end

%%  spusteni simulace
    load 'optimproblem1.mat'

    %   smycka v niz probihaji iterace...
    for i=1:ceil(GAR.Optimization_Info.Iterations_Count/GAR.Optimization_Info.Plot_Interval)
%%  samotny proces optimalizace (pomoci genetickeho algoritmu)
        warning('off','gads:initialPopulationCheck:initPopLength');
        [X,FVAL,EXITFLAG,OUTPUT,POPULATION,SCORES] = ga(...
            optimproblem1.fitnessfcn,optimproblem1.nvars,...
            [],[],[],[],[GAR.GA_Matlab.min_rozsahu],[GAR.GA_Matlab.max_rozsahu],[],optimproblem1.options);

        optimproblem1.options=gaoptimset(optimproblem1.options, ...
        'InitialPopulation',POPULATION,'InitialScores',SCORES);

%%  vypis vysledku
    gar_results_printing_en(X,FVAL,i);
%%  screen prbnch vsledk
    if GAR.Optimization_Info.Screen_saveing
        gar_screen_saving2(X,GAR.Model_Settings.System_TF,...
            i,GAR.Optimization_Info.GAR_type,...
            GAR.Optimization_Info.Plot_Interval); 
    end
%%  kratka prodleva pred dalsimi iteracemi
    pause(0.1)
    end
    
    [reg,Z,P,K,KID,Ts]=gar_reg_rek(X);  %rekonstrukce regultoru (nvratov parametry)
    
end