% kriterialni funkce
function x=simulacee(KID)
%% globalni promnn
global GAR
t=GAR.Optimization_Info.Simulation_Time;

%%  parametry regulatoru - dekdovn DNA
[Z,P,K,Ts]=transformace(KID);

%%  simulace    
try 
    if GAR.Optimization_Info.Use_Simulink_model
        warning('off', 'all');
        sim('./soustava3.mdl',[],simset('SrcWorkspace', 'current'))
        warning('on', 'all');
        control_value=simout.signals.values;
        tout0=simout.time;
        control_action=simout1.signals.values;
    else
        regulator_xy=tf(zpk(Z,P,K));
        system_tf=GAR.Model_Settings.System_TF;
        tout0=linspace(0,t,5000)';
        forward_track=minreal(series(regulator_xy,system_tf));
        if GAR.Model_Settings.t_delay
            forward_track=ss(forward_track);
            regulator_xy=ss(regulator_xy);
            system_tf=ss(system_tf);
        end
        control_loop=feedback(forward_track,1);
        control_value=step(control_loop,tout0);
        action_loop=feedback(regulator_xy,system_tf);
        control_action=step(action_loop,tout0);
    end
    
    %%  vypocet fitness
    x=penalizace(control_value,control_action,tout0);
    
    GAR.Optimization_Info.individuals_ok=GAR.Optimization_Info.individuals_ok+1;
catch
    x=1e10;    % pokud jsou parametry nekorektni, nastavi se velka hodnota fitness 
    GAR.Optimization_Info.individuals_error=GAR.Optimization_Info.individuals_error+1;
end            % funkce vraci spocitanou hodnotu fitness

