% funkce pro vpoet nastaven PID regultoru podle metody Ziegler-Nichols
function [Kp Ki Kd]=ziegnich2(soustava)

[Gm,Pm,Wcg,Wcp]=margin(soustava);
if isinf(Gm)
    reg=tf(0);
    disp('ZN nefunguje, soustava nejde rozkmitat')
    return
end

K_krit=Gm;
T_krit=1/(Wcg/(2*pi));

Kp=0.6*K_krit;
Ki=2*Kp/T_krit;
Kd=Kp*T_krit/8;
% http://en.wikipedia.org/wiki/Ziegler%E2%80%93Nichols_method#cite_note-microstar-1
% http://www.352.vsb.cz/uc_texty/Identifikace/synteza/synteza.htm


p=tf('p');
reg=Kp+Ki/p+Kd*p/(1e-2*p+1);
