% funkce pro aktualizaci simulanho modelu (m vliv jem pi pouit Simulinku)
function gar_modelPID_update
global GAR

%%  ulozeni parametru (aktualizace simulacniho modelu)
    open_system('soustava_pid')
    warning('off', 'all');
%    get_param('soustava_pid/Dead_Zone', 'DialogParameters')

    set_param('soustava_pid', 'StopTime', ...
        num2str(GAR.Optimization_Info.Simulation_Time))
    set_param('soustava_pid', 'MaxStep', ...
        num2str(round(1000*GAR.Optimization_Info.Simulation_Time/...
                GAR.Optimization_Info.Simulation_Time_Steps_Minimum)/1000))
   
    set_param('soustava_pid/zadanahodnota', 'After', ...
        num2str(GAR.Control_Requirements.Set_Value))
    set_param('soustava_pid/t_delay', 'DelayTime', ...
        num2str(GAR.Model_Settings.t_delay))
    set_param('soustava_pid/Saturation', 'UpperLimit', ...
        num2str(GAR.Model_Settings.Saturation_UpperLimit))
    set_param('soustava_pid/Saturation', 'LowerLimit', ...
        num2str(GAR.Model_Settings.Saturation_LowerLimit))
    set_param('soustava_pid/DeadZone', 'LowerValue', ...
        num2str(GAR.Model_Settings.DeadZone_LowerLimit))
    set_param('soustava_pid/DeadZone', 'UpperValue', ...
        num2str(GAR.Model_Settings.DeadZone_UpperLimit))
    
    if GAR.Model_Settings.optimalizovat_vzorkovani_on
     set_param('soustava_pid/regulator/PSD/Unit Delay', 'SampleTime','Ts')
     set_param('soustava_pid/regulator/PSD/Unit Delay1', 'SampleTime','Ts')
     set_param('soustava_pid/regulator/PSD/Gain1', 'Gain','Ts/I')
     set_param('soustava_pid/regulator/PSD/Gain2', 'Gain','D/Ts')
    else
         set_param('soustava_pid/regulator/PSD/Unit Delay', 'SampleTime',...
            num2str(GAR.Model_Settings.vzorkovani_regulatoru))
         set_param('soustava_pid/regulator/PSD/Unit Delay1', 'SampleTime',...
            num2str(GAR.Model_Settings.vzorkovani_regulatoru))
         set_param('soustava_pid/regulator/PSD/Gain1', 'Gain',...
            [num2str(GAR.Model_Settings.vzorkovani_regulatoru) '/I'])
         set_param('soustava_pid/regulator/PSD/Gain2', 'Gain',...
            ['D/' num2str(GAR.Model_Settings.vzorkovani_regulatoru)])
    end
    
    set_param('soustava_pid/ZOH1', 'SampleTime', ...
        num2str(GAR.Model_Settings.vzorkovani_vystupu))
    set_param('soustava_pid/RandomGenerator', 'SampleTime', ...
        num2str(min(GAR.Model_Settings.vzorkovani_regulatoru,...
                GAR.Model_Settings.vzorkovani_vystupu)))
    set_param('soustava_pid/RandomGenerator', 'Minimum',...
        num2str(-GAR.Model_Settings.Noise_In_Feedback_Size))
    set_param('soustava_pid/RandomGenerator', 'Maximum',...
        num2str(GAR.Model_Settings.Noise_In_Feedback_Size))
     %set_param('soustava_pid/WhiteNoise', 'Cov',...
     %    num2str(GAR.Model_Settings.Noise_In_System_Size))
    set_param('soustava_pid/RandomGenerator1', 'Minimum',...
        num2str(-GAR.Model_Settings.Noise_In_System_Size))
    set_param('soustava_pid/RandomGenerator1', 'Maximum',...
        num2str(GAR.Model_Settings.Noise_In_System_Size))
    set_param('soustava_pid/ZOH2', 'SampleTime', ...
        num2str(GAR.Model_Settings.vzorkovani_vystupu*10))
    
    set_param('soustava_pid/TF1', 'Numerator', ...
        ['[' num2str(GAR.Model_Settings.System_num) ']'])
    set_param('soustava_pid/TF1', 'Denominator', ...
        ['[' num2str(GAR.Model_Settings.System_den) ']'])
    
    set_param('soustava_pid/sample_off', 'Value', ...
        num2str(~GAR.Model_Settings.vzorkovani_regulatoru_on))
    set_param('soustava_pid/sample2_off', 'Value', ...
        num2str(~GAR.Model_Settings.vzorkovani_vystupu_on))
    set_param('soustava_pid/dzone_off', 'Value', ...
        num2str(~GAR.Model_Settings.DeadZone_On))
    set_param('soustava_pid/satur_off', 'Value', ...
        num2str(~GAR.Model_Settings.Saturation_On))
    set_param('soustava_pid/noise_on', 'Value', ...
        num2str(GAR.Model_Settings.Noise_In_System_On))
    set_param('soustava_pid/rand_on', 'Value', ...
        num2str(GAR.Model_Settings.Noise_In_Feedback_On))
    
    save_system('soustava_pid')
    warning('on', 'all');
    close_system('soustava_pid')
