% funkce pro vpis (dlch) vsledk optimalizace
function gar_results_printing(X,FVAL,i)

global GAR;
global fitness_history;
t=GAR.Optimization_Info.Simulation_Time;

%       historie nejlepsich fitness (pro moznost sledovani vyvoje fitness)
        fitness_history(i)=FVAL;

        disp(['nejlepsi dosud nalezeny fitness: [' num2str(FVAL) '] po ' ...
             num2str(GAR.Optimization_Info.Plot_Interval*i) '. iteraci']);

%%  vykresleni vysledku
%       data pro vykresleni prubehu optimalizace
    if strcmp(GAR.Optimization_Info.GAR_type,'GAPID')
        [vystup, tout0, zasah, tout1]=vykresleniPID(X);
    else
        [vystup, tout0, zasah, tout1]=vykresleni(X);
    end

%       vykresleni odezvy v casove oblasti
        subplot(2,1,1)
        plot(tout0,vystup);
        grid on;
        XLim=[0 t];
        YLim=[min([0-0.5*abs(GAR.Control_Requirements.Set_Value) ...
                GAR.Control_Requirements.Set_Value-...
                0.5*abs(GAR.Control_Requirements.Set_Value)]) ...
            max([0+0.5*abs(GAR.Control_Requirements.Set_Value) ...
                GAR.Control_Requirements.Set_Value+...
                0.5*abs(GAR.Control_Requirements.Set_Value)])];
            axis([XLim YLim])
            xlabel('as [s]');
            ylabel('odezva soustavy [-]');

%       vykresleni vyvoje nejlepsiho fitness, nebo...
        if GAR.Optimization_Info.Second_Graph
            subplot(2,1,2)
            plot(max(1,GAR.Optimization_Info.Plot_Interval):...
                    max(1,GAR.Optimization_Info.Plot_Interval):...
                    max(1,GAR.Optimization_Info.Plot_Interval)*...
                length(fitness_history(fitness_history~=0)),...
                fitness_history,'x');
            grid on;
            XLim=[0 length(fitness_history(fitness_history~=0))*...
                max(1,GAR.Optimization_Info.Plot_Interval)];
            YLim=[min(0,min(fitness_history)) max(fitness_history)];
            axis([XLim YLim])
            xlabel('as [s]');
            ylabel('Fitness nejlepho jedince [-]');
        else
            
%       vykresleni akcniho zasahu
            subplot(2,1,2)
            plot(tout1,zasah);
            grid on;
            XLim=[0 t];
            YLim=1.2*[min(0,min(zasah))-1 ...
                max(0,max(zasah))+1];
            axis([XLim YLim])
            xlabel('as [s]');
            ylabel('Akn zsah [-]');
        end

        
%%  vypis vysledku

    if strcmp(GAR.Optimization_Info.GAR_type,'GAPID')
        disp(['K=' num2str(abs(X(1)))]);
        disp(['I=' num2str(abs(X(2)))]);
        disp(['D=' num2str(abs(X(3)))]);
    else
        [Z,P,K,Ts]=transformace(X);
        disp(['Z=' num2str(Z)]);
        disp(['P=' num2str(P)]);
        disp(['K=' num2str(K)]);
    end
        if ~GAR.Model_Settings.vzorkovani_regulatoru_on
            disp('');
        elseif ~GAR.Model_Settings.Optimize_Sampling
            disp(print_Ts);
        else
            disp([print_Ts num2str(abs(Ts))]);
        end
                
        disp(['max. hodnota: ' num2str(max(vystup))]);
        disp(['max. prekmit: ' max(num2str(0.01*round(...
            max(vystup-GAR.Control_Requirements.Set_Value)/...
            GAR.Control_Requirements.Set_Value*100*100)),0) ' %']);
        
        pres_devadesat_procent=vystup>0.9*GAR.Control_Requirements.Set_Value;
        [pp,poz90]=max(pres_devadesat_procent);
        disp(['Prvni dosazeni 90%: ' num2str(tout0(poz90)) ' s']);
                
        odchylka=GAR.Control_Requirements.Set_Value-vystup;
        itaee=sum(abs( ((odchylka(1:end-1)+odchylka(2:end))/2 )...
            .*tout0(2:end)).*(tout0(2:end)-tout0(1:end-1)));
        kvadd=sum((odchylka(2:end).^2).*(tout0(2:end)-tout0(1:end-1)));
        linn=sum(abs(odchylka(2:end)).*(tout0(2:end)-tout0(1:end-1)));
        disp(['hodnota kriteria ITAE: ' num2str(itaee)]);
        disp(['hodnota kvad. krit.: ' num2str(kvadd)]);
        disp(['hodnota lin. krit.: ' num2str(linn)]);
        disp(['Vysledky po iteraci ' num2str(...
            i*max(1,GAR.Optimization_Info.Plot_Interval))]);

        disp(['OK/errors: ' num2str(GAR.Optimization_Info.individuals_ok)...
            ' / ' num2str(GAR.Optimization_Info.individuals_error)]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% modifikace asov osy
if GAR.Optimization_Info.Simulation_Time_Modify
    if( sum(abs(vystup(round(length(vystup)/2):end)-1)) <  10e-1 )
        GAR.Optimization_Info.Simulation_Time=GAR.Optimization_Info.Simulation_Time/2;
    else
        GAR.Optimization_Info.Simulation_Time=GAR.Optimization_Info.Simulation_Time*2;
    end
end