% aktualizace nastaven GA eie
function gar_solver_update

global GAR;

%%  vzgenerovani optimalizacniho problemu
    optimproblem1.options=gaoptimset;
    if strcmp(GAR.Optimization_Info.GAR_type,'GAPID')
        optimproblem1.fitnessfcn=@(x)simulaceePID(x);
    else
    optimproblem1.fitnessfcn=@(x)simulacee(x);
    end
    optimproblem1.nvars=GAR.GA_Matlab.delka_DNA;
    optimproblem1.solver='ga';

%%  nastaveni parametru genetickeho algoritmu
%   velikost populace
    population_size=GAR.GA_Matlab.velikost_populace;
    if isnan(population_size) || population_size<2
        disp('pocet generaci 20 (default)');
    else
        optimproblem1.options=gaoptimset(optimproblem1.options, ...
        'PopulationSize',population_size);
    end

%   zobrazovani fitness cele populace "ano/ne"   
    if GAR.Optimization_Info.Display_Fitness
        optimproblem1.options=gaoptimset(optimproblem1.options, ...
        'PlotFcns', {@gaplotscores},'PlotInterval', ...
        max(1,GAR.Optimization_Info.Plot_Interval));
    else
        optimproblem1.options=gaoptimset(optimproblem1.options, ...
        'PlotFcns', [],'PlotInterval',[]);
    end
    
%   interval vykreslovani mezivysledku, tj. pocet generaci do vykresleni    
    optimproblem1.options=gaoptimset(optimproblem1.options, ...
        'Generations',max(1,GAR.Optimization_Info.Plot_Interval));

%   volba zpusobu krizeni   
     switch(GAR.GA_Matlab.typ_krizeni)
        case 1
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'CrossoverFcn', @crossoverscattered);
        case 2
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'CrossoverFcn', @crossoversinglepoint);
        case 3
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'CrossoverFcn', @crossovertwopoint);
        case 4
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'CrossoverFcn', {@crossoverintermediate, []});
        case 5
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'CrossoverFcn', {@crossoverintermediate, []});
         otherwise
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'CrossoverFcn', @crossoverscattered);
     end
     
%    volba zpusobu vyberu jedince pro krizeni
     switch(GAR.GA_Matlab.typ_vyberu_jedince)
        case 1
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'SelectionFcn', @selectionstochunif);
        case 2
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'SelectionFcn', @selectionuniform);
        case 3
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'SelectionFcn', @selectionroulette);
        case 4
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'SelectionFcn', {@selectiontournament, []});
         otherwise
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'SelectionFcn', @selectionstochunif);
     end
     
%    vyber zpusobu mutace 
     switch(GAR.GA_Matlab.druh_mutace)
        case 1
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'MutationFcn', @mutationadaptfeasible);        
        case 2
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'MutationFcn', {@mutationuniform, 0.3} );
        case 3
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'MutationFcn', @mutationgaussian);
         otherwise
            optimproblem1.options=gaoptimset(optimproblem1.options, ...  
            'MutationFcn', @mutationadaptfeasible);        
     end

    % options = gaoptimset(options,'Display', 'off');
    % options = gaoptimset(options,'OutputFcns', { [] });

     
%    vygenerovani pocatecniho stavu populace
     optimproblem1.options=gaoptimset(optimproblem1.options, ...
         'InitialPopulation',(-0.5+...
         randn(GAR.GA_Matlab.velikost_populace,optimproblem1.nvars))./...
         randn(GAR.GA_Matlab.velikost_populace,optimproblem1.nvars));

     
%    ulozeni optimalizacniho problemu     
    save 'optimproblem1' 'optimproblem1'